cls;
library pgraph;
graphset;
format /ro 7,4;
clear graphmat,dat;
shkpath = "d:\\ssretire\\shk\\";

_pdate   = "";                @ date is not printed    @
_plctrl  = {0, 0, 0, 0 };     @ curves without symbols @
_pstype  = {0, 0, 0};         @ symbol types           @
_pcolor  = {3, 6, 4, 0};      @ set white color        @
_plwidth = {8,8,8,8};
_pltype  = (6|5|3|1);
_pmcolor = zeros(8,1)|15;
_ptitlht = 0.18;
xtics(58,69,1,miss(0,0));

load path = ^shkpath graphmat;
" graphmat = " graphmat;?;
dat = graphmat;
rootdir = "-C=1 -CF=d:\\ssretire\\graphs\\";

filestr = rootdir $+ "assets.eps";
grphasst(dat,filestr,4);

filestr = rootdir $+ "assetsd.eps";
grphasst(dat,filestr,2);

filestr = rootdir $+ "hours.eps";
grphhour(dat,filestr);

filestr = rootdir $+ "lfpr.eps";
grphlfpr(dat,filestr);


age = dat[.,1];

dat2 = dat[.,6:8];
titlestr = "Participation Rates, Data, No Health Insurance";
_plegstr = "Low assets, no H.I., data\000Medium assets, no H.I., data \000High assets, no H.I., data ";
filestr  = rootdir $+ "lfprdn.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2 = dat[.,9:11];
titlestr = "Participation Rates, Data, Retiree Health Insurance";
_plegstr = "Low assets, retiree H.I., data\000Medium assets, retiree H.I., data \000High assets, retiree H.I., data ";
filestr  = rootdir $+ "lfprdr.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2 = dat[.,12:14];
titlestr = "Participation Rates, Data, Tied Health Insurance";
_plegstr = "Low assets, tied H.I., data\000Medium assets, tied H.I., data \000High assets, tied H.I., data ";
filestr  = rootdir $+ "lfprdt.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2 = dat[.,21:23];
titlestr = "Participation, Simulations, No Health Insurance";
_plegstr = "Low assets, no H.I., simulations\000Medium assets, no H.I., simulations \000High assets, no H.I., simulations ";
filestr  = rootdir $+ "lfprsn.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2 = dat[.,24:26];
titlestr = "Participation, Simulations, Retiree Health Insurance";
_plegstr = "Low assets, retiree H.I., simulations\000Medium assets, retiree H.I., simulations \000High assets, retiree H.I., simulations ";
filestr  = rootdir $+ "lfprsr.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2 = dat[.,27:29];
titlestr = "Participation, Simulations, Tied Health Insurance";
_plegstr = "Low assets, tied H.I., simulations\000Medium assets, tied H.I., simulations \000High assets, tied H.I., simulations ";
filestr  = rootdir $+ "\\lfprst.eps";
grphlfp2(age,dat2,filestr,titlestr);


end;


proc(0) = grphasst(dat,filestr,rn);

    local rscl, adl, adh, asl, ash, y, age, x, liner1, liner2, liner3,
          liner4, liner5, liner6, liner7;

    rscl = 1e3;

    adl=dat[.,15]*rscl; @ 1/3rd asset quantile, data @
    adh=dat[.,16]*rscl; @ 2/3rd asset quantile, data @
    asl=dat[.,30]*rscl; @ 1/3rd asset quantile, simulation @
    ash=dat[.,31]*rscl; @ 1/3rd asset quantile, simulation @
    if rn==2;
        y=adl~adh;
    elseif rn==4;
        y=adl~asl~adh~ash;
    endif;

    x=dat[.,1];

    if rn==2;
        _plegstr = "1/3rd quantile, data \0002/3rd quantile, data";
        _plegctl = {2,5,1,5.5};   @ legend size and location @
    elseif rn==4;
        _plegstr = "1/3rd quantile, data \0001/3rd quantile, simulations \0002/3rd quantile, data, \0002/3rd quantile, simulations";
        _plegctl = {2,5,1,5};   @ legend size and location @
    endif;
/*    
    liner1=1~2~20~50000~80~50000~1~1~1;
    liner2=1~2~20~100000~80~100000~1~1~1;
    liner3=1~2~20~150000~80~150000~1~1~1;
    liner4=1~2~20~200000~80~200000~1~1~1;
    liner5=1~2~20~250000~80~250000~1~1~1;
    liner6=1~2~20~300000~80~300000~1~1~1;
    liner7=1~2~20~350000~80~350000~1~1~1;
*/
    liner1=1~2~20~50~80~50~1~1~1;
    liner2=1~2~20~100~80~100~1~1~1;
    liner3=1~2~20~150~80~150~1~1~1;
    liner4=1~2~20~200~80~200~1~1~1;
    liner5=1~2~20~250~80~250~1~1~1;
    liner6=1~2~20~300~80~300~1~1~1;
    liner7=1~2~20~350~80~350~1~1~1;

    _pline=liner1|liner2|liner3|liner4|liner5|liner6|liner7;
    
    ylabel("Assets (thousands of 1998 dollars)");
    xlabel("Age");

    ytics(0,350,50,miss(0,0));

    graphprt(filestr); 
    xy(x,y);
    pause(5);

retp; endp;


proc(0) = grphhour(dat,filestr);

    local hd, ud, hs, us, y, age, x, liner1, liner2, liner3,
          liner4, liner5;

    hd=dat[.,3];   @ healthy hours, data          @
    ud=dat[.,2];   @ unhealthy hours, data        @
    hs=dat[.,18];  @ healthy hours, simulations   @
    us=dat[.,17];  @ unhealthy hours, simulations @
    y=exp(hd~hs~ud~us);

    x=dat[.,1];

    _plegctl = {2,5,1,1};  @ legend size and location @
    _plegstr = "Healthy, data \000Healthy, simulations \000Unhealthy, data \000Unhealthy, simulations ";

    liner1=1~2~20~1250~80~1250~1~1~1;
    liner2=1~2~20~1500~80~1500~1~1~1;
    liner3=1~2~20~1750~80~1750~1~1~1;
    liner4=1~2~20~2000~80~2000~1~1~1;
    liner5=1~2~20~2250~80~2250~1~1~1;
    _pline=liner1|liner2|liner3|liner4|liner5;

    ylabel("Hours");
    xlabel("Age");
    title ("Annual Hours Worked, Simulations Versus Data");
    ytics(1000,2500,250,miss(0,0));

    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;


proc(0) = grphlfpr(dat,filestr);

    local hlfprd, ulfprd, hlfprs, ulfprs, y, age, x, liner1, liner2, 
          liner3, liner4;

    hlfprd=dat[.,5];   @ healthy lfpr, data          @
    ulfprd=dat[.,4];   @ unhealthy lfpr, data        @
    hlfprs=dat[.,20];  @ healthy lfpr, simulations   @
    ulfprs=dat[.,19];  @ unhealthy lfpr, simulations @
    y=hlfprd~hlfprs~ulfprd~ulfprs;

    x=dat[.,1];

    _plegctl = {2,5,1,1};  @ legend size and location @
    _plegstr = "Healthy, data \000Healthy, simulations \000Unhealthy, data \000Unhealthy, simulations ";

    liner1=1~2~20~0.2~80~0.2~1~1~1;
    liner2=1~2~20~0.4~80~0.4~1~1~1;
    liner3=1~2~20~0.6~80~0.6~1~1~1;
    liner4=1~2~20~0.8~80~0.8~1~1~1;
    _pline=liner1|liner2|liner3|liner4;

    ylabel("Participation Rates");
    xlabel("Age");
    title ("Labor Force Participation Rates, Data Versus Simulations");
    ytics(0,1,0.1,miss(0,0));
    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;

proc(0) = grphlfp2(age,dat,filestr,titlestr);

    local y, x, liner1, liner2, liner3, liner4;

    y=dat;
    x=age;

    _plegctl = {2,5,1,1};  @ legend size and location @

    liner1=1~2~20~0.2~80~0.2~1~1~1;
    liner2=1~2~20~0.4~80~0.4~1~1~1;
    liner3=1~2~20~0.6~80~0.6~1~1~1;
    liner4=1~2~20~0.8~80~0.8~1~1~1;
    _pline=liner1|liner2|liner3|liner4;

    ylabel("Participation Rates");
    xlabel("Age");
    title (titlestr);
    ytics(0,1,0.1,miss(0,0));

    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;

