cls;
library pgraph;
graphset;
format /ro 7,4;
clear grphmat2,dat;
shkpath = "d:\\ssretire\\shk\\";

_pdate   = "";                @ date is not printed    @
_plctrl  = {0, 1, 1, 1 };     @ 1 => symbol            @
_pstype  = {0, 0, 0};         @ 0 => empty, 1=> filled @
_pcolor  = {0, 0, 0, 0};      @ 0 => black lines       @
_plwidth = {8,8,8,8};
_pltype  = (6|5|3|1);
_pmcolor = zeros(8,1)|15;
_ptitlht = 0.18;
_plegctl = {2,6,1,4.5};     @ legend size and location @
xtics(59,69,1,miss(0,0));
ytics(0,0.4,0.1,miss(0,0));
rootdir = "-C=1 -CF=d:\\ssretire\\graphs\\";

load path = ^shkpath grphmat2;
" graphmat = " grphmat2;?;
dat = grphmat2[2:rows(grphmat2),.];
age = dat[.,1];
cn  = cols(dat);
if cn < 19;
    dat = dat~zeros(rows(dat),19-cn);
endif;
dat = dat[.,2:19@10@];

liner1=1~2~20~0.1~80~0.1~1~1~1;
liner2=1~2~20~0.2~80~0.2~1~1~1;
liner3=1~2~20~0.3~80~0.3~1~1~1;
_pline=liner1|liner2|liner3;

dat2 = dat[.,1:3];
titlestr = "Job Exit Rates, Data, No Health Insurance";
_plegstr = "Low assets, no H.I., data\000Medium assets, no H.I., data \000High assets, no H.I., data ";
filestr  = rootdir $+ "hazdn_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

dat2 = dat[.,4:6];
titlestr = "Job Exit Rates, Data, Retiree Health Insurance";
_plegstr = "Low assets, retiree H.I., data\000Medium assets, retiree H.I., data \000High assets, retiree H.I., data ";
filestr  = rootdir $+ "hazdr_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

dat2 = dat[.,7:9];
titlestr = "Job Exit Rates, Data, Tied Health Insurance";
_plegstr = "Low assets, tied H.I., data\000Medium assets, tied H.I., data \000High assets, tied H.I., data ";
filestr  = rootdir $+ "hazdt_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

dat2 = dat[.,10:12];
titlestr = "Job Exit Rates, Simulations, No Health Insurance";
_plegstr = "Low assets, no H.I., simulations\000Medium assets, no H.I., simulations \000High assets, no H.I., simulations ";
filestr = rootdir $+ "hazsn_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

dat2 = dat[.,13:15];
titlestr = "Job Exit Rates, Simulations, Retiree Health Insurance";
_plegstr = "Low assets, retiree H.I., simulations\000Medium assets, retiree H.I., simulations \000High assets, retiree H.I., simulations ";
filestr = rootdir $+ "hazsr_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

dat2 = dat[.,16:18];
titlestr = "Job Exit Rates, Simulations, Tied Health Insurance";
_plegstr = "Low assets, tied H.I., simulations\000Medium assets, tied H.I., simulations \000High assets, tied H.I., simulations ";
filestr = rootdir $+ "hazst_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

end;

proc(0) = grphhaz(age,dat,filestr,titlestr);

    local x, y, x0, y1;

    y=dat;
    x=age~age~age;
    ylabel("Job Exit Rates");
    xlabel("Age");
    title(titlestr);
    graphprt(filestr); 
    xy(x,y);
    pause(5);
 retp; endp;
