cls;
library pgraph;
graphset;
format /ro 7,4;
clear graphmat,dat;
shkpath = "d:\\ssretire\\shk\\";

_pdate   = "";                @ date is not printed    @
_plctrl  = {0, 1, 1, 1 };     @ 1 => symbol            @
_pstype  = {0, 0, 0};         @ 0 => empty, 1=> filled @
_pcolor  = {0, 0, 0, 0};      @ 0 => black lines       @
_plwidth = {8,8,8,8};
_pltype  = (6|5|3|1);
_pmcolor = zeros(8,1)|15;
_ptitlht = 0.18;
_plegctl = {2,5,1,1};  @ legend size and location @
xtics(58,69,1,miss(0,0));
ytics(0,1,0.1,miss(0,0));
rootdir = "-C=1 -CF=d:\\ssretire\\graphs\\";

load path = ^shkpath grphmat3;
" grphmat3 = " grphmat3;?;
dat = grphmat3;

age = dat[.,1];
cn  = 2|10;

dat2 = dat[.,cn];
titlestr = "Participation Rates, All Health Insurance Types";
_plegstr = "Data, All H.I.\000Simulations, All H.I.";
filestr  = rootdir $+ "aglfpr_bw.eps";
grphlfp2(age,dat2,filestr,titlestr);

cn = cn+1;

dat2 = dat[.,cn];
titlestr = "Participation Rates, No Health Insurance";
_plegstr = "Data, no H.I.\000Simulations, no H.I.";
filestr  = rootdir $+ "aglfprn_bw.eps";
grphlfp2(age,dat2,filestr,titlestr);

cn = cn+1;
dat2 = dat[.,cn];
titlestr = "Participation Rates, Retiree Health Insurance";
_plegstr = "Data, retiree H.I.\000Simulations, retiree H.I.";
filestr  = rootdir $+ "aglfprr_bw.eps";
grphlfp2(age,dat2,filestr,titlestr);

cn = cn+1;
dat2 = dat[.,cn];
titlestr = "Participation Rates, Tied Health Insurance";
_plegstr = "Data, tied H.I.\000Simulations, tied H.I.";
filestr  = rootdir $+ "aglfprt_bw.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2 = dat[.,3|4|5];
titlestr = "Participation Rates by Health Insurance Type, Data";
_plegstr = "Data, no H.I. \000Data, retiree H.I. \000Data, tied H.I.";
filestr  = rootdir $+ "\\lfprdall_bw.eps";
grphlfp2(age,dat2,filestr,titlestr);

xtics(59,69,1,miss(0,0));
ytics(0,0.3,0.05,miss(0,0));
liner1=1~2~20~0.05~80~0.05~1~1~1;
liner2=1~2~20~0.1~80~0.1~1~1~1;
liner3=1~2~20~0.15~80~0.15~1~1~1;
liner4=1~2~20~0.2~80~0.2~1~1~1;
liner5=1~2~20~0.25~80~0.25~1~1~1;
_pline=liner1|liner2|liner3|liner4|liner5;

age = trimr(age,1,0);
dat = trimr(dat,1,0);

_plegctl = {2,5,1,5};   @ legend size and location @

cn = cn+1;
dat2 = dat[.,cn];
titlestr = "Job Exit Rates, All Health Insurance Types";
_plegstr = "Data, All H.I.\000Simulations, All H.I.";
filestr = rootdir $+ "aghaz_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

cn = cn+1;
dat2 = dat[.,cn];
titlestr = "Job Exit Rates, No Health Insurance";
_plegstr = "Data, no H.I.\000Simulations, no H.I.";
filestr = rootdir $+ "aghazn_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

cn = cn+1;
dat2 = dat[.,cn];
titlestr = "Job Exit Rates, Retiree Health Insurance";
_plegstr = "Data, retiree H.I.\000Simulations, retiree H.I.";
filestr = rootdir $+ "aghazr_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

cn = cn+1;
dat2 = dat[.,cn];
titlestr = "Job Exit Rates, Tied Health Insurance";
_plegstr = "Data, tied H.I.\000Simulations, tied H.I.";
filestr = rootdir $+ "aghazt_bw.eps";
grphhaz(age,dat2,filestr,titlestr);

_plegctl = {2,5,1,4.7};   @ legend size and location @

dat2 = dat[.,7|8|9];
titlestr = "Job Exit Rates by Health Insurance Type, Data";
_plegstr = "Data, no H.I. \000Data, retiree H.I. \000Data, tied H.I.";
filestr = rootdir $+ "hazdall_bw.eps";
grphhaz(age,dat2,filestr,titlestr);
end;



proc(0) = grphlfp2(age,dat,filestr,titlestr);

    local y,  x, liner1, liner2, liner3, liner4, x0, y1;

    y=dat;
    x=age*ones(1,cols(y));

    liner1=1~2~20~0.2~80~0.2~1~1~1;
    liner2=1~2~20~0.4~80~0.4~1~1~1;
    liner3=1~2~20~0.6~80~0.6~1~1~1;
    liner4=1~2~20~0.8~80~0.8~1~1~1;
    _pline=liner1|liner2|liner3|liner4;

    ylabel("Participation Rates");
    xlabel("Age");
    title (titlestr);

    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;


proc(0) = grphhaz(age,dat,filestr,titlestr);

    local x, y;

    y=dat;
    x=age*ones(1,cols(y));
    ylabel("Job Exit Rates");
    xlabel("Age");
    title(titlestr);
    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;