cls;
library pgraph;
graphset;
format /ro 7,4;
clear graphmat, dat;
shkpath = "d:\\ssretire\\shk\\";
rootdir = "-C=1 -CF=d:\\ssretire\\graphs\\";

_pdate   = "";                @ date is not printed    @
_plctrl  = {0, 1, 1, 1 };     @ curves without symbols @
_pstype  = {0, 8, 11, 10};    @ symbol types           @
_pcolor  = {3, 6, 4, 0};      @ set white color        @
_plwidth = {8,8,8,8};
_pltype  = (6|6|3|6);
_pmcolor = zeros(8,1)|15;
_ptitlht = 0.18;
xtics(58,69,1,miss(0,0));

load path  = ^shkpath graphmat;
" graphmat = " graphmat;?;

dat      = graphmat;
age      = dat[.,1];

filestr  = rootdir $+ "assets.eps";
grphasst(dat,filestr,4);

filestr  = rootdir $+ "assetsd.eps";
grphasst(dat,filestr,2);

filestr  = rootdir $+ "hours.eps";
grphhour(dat,filestr);

filestr  = rootdir $+ "lfpr.eps";
grphlfpr(dat,filestr);

dat2     = dat[.,6:8];
titlestr = "Participation Rates, Data, No Health Insurance";
_plegstr = "Low assets, no H.I., data\000Medium assets, no H.I., data \000High assets, no H.I., data ";
filestr  = rootdir $+ "lfprdn.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2     = dat[.,9:11];
titlestr = "Participation Rates, Data, Retiree Health Insurance";
_plegstr = "Low assets, retiree H.I., data\000Medium assets, retiree H.I., data \000High assets, retiree H.I., data ";
filestr  = rootdir $+ "lfprdr.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2     = dat[.,12:14];
titlestr = "Participation Rates, Data, Tied Health Insurance";
_plegstr = "Low assets, tied H.I., data\000Medium assets, tied H.I., data \000High assets, tied H.I., data ";
filestr  = rootdir $+ "lfprdt.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2     = dat[.,21:23];
titlestr = "Participation, Simulations, No Health Insurance";
_plegstr = "Low assets, no H.I., simulations\000Medium assets, no H.I., simulations \000High assets, no H.I., simulations ";
filestr  = rootdir $+ "lfprsn.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2     = dat[.,24:26];
titlestr = "Participation, Simulations, Retiree Health Insurance";
_plegstr = "Low assets, retiree H.I., simulations\000Medium assets, retiree H.I., simulations \000High assets, retiree H.I., simulations ";
filestr  = rootdir $+ "lfprsr.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2     = dat[.,27:29];
titlestr = "Participation, Simulations, Tied Health Insurance";
_plegstr = "Low assets, tied H.I., simulations\000Medium assets, tied H.I., simulations \000High assets, tied H.I., simulations ";
filestr  = rootdir $+ "\\lfprst.eps";
grphlfp2(age,dat2,filestr,titlestr);

@-----------------------------------------------------------------------------@
@-----Graph lfpr and exit rates that are NOT disaggregated by asset level-----@

load path = ^shkpath grphmat3;
" grphmat3 = " grphmat3;?;

dat      = grphmat3;
age      = dat[.,1];
cn       = 2|10;

dat2     = dat[.,cn];
titlestr = "Participation Rates, All Health Insurance Types";
_plegstr = "Data, All H.I.\000Simulations, All H.I.";
filestr  = rootdir $+ "aglfpr.eps";
grphlfp2(age,dat2,filestr,titlestr);

cn       = cn+1;
dat2     = dat[.,cn];
titlestr = "Participation Rates, No Health Insurance";
_plegstr = "Data, no H.I.\000Simulations, no H.I.";
filestr  = rootdir $+ "aglfprn.eps";
grphlfp2(age,dat2,filestr,titlestr);

cn       = cn+1;
dat2     = dat[.,cn];
titlestr = "Participation Rates, Retiree Health Insurance";
_plegstr = "Data, retiree H.I.\000Simulations, retiree H.I.";
filestr  = rootdir $+ "aglfprr.eps";
grphlfp2(age,dat2,filestr,titlestr);

cn       = cn+1;
dat2     = dat[.,cn];
titlestr = "Participation Rates, Tied Health Insurance";
_plegstr = "Data, tied H.I.\000Simulations, tied H.I.";
filestr  = rootdir $+ "aglfprt.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2     = dat[.,3|4|5];
titlestr = "Participation Rates by Health Insurance Type, Data";
_plegstr = "Data, no H.I. \000Data, retiree H.I. \000Data, tied H.I.";
filestr  = rootdir $+ "\\lfprdall.eps";
grphlfp2(age,dat2,filestr,titlestr);

dat2     = dat[.,11|12|13];
titlestr = "Participation Rates by Health Insurance Type, Simulations";
_plegstr = "Simulations, no H.I. \000Simulations, retiree H.I. \000Simulations, tied H.I.";
filestr  = rootdir $+ "\\lfprsall.eps";
grphlfp2(age,dat2,filestr,titlestr);

xtics(59,69,1,miss(0,0));
ytics(0,0.3,0.05,miss(0,0));
liner1   = 1~2~20~0.05~80~0.05~1~1~1;
liner2   = 1~2~20~0.1~80~0.1~1~1~1;
liner3   = 1~2~20~0.15~80~0.15~1~1~1;
liner4   = 1~2~20~0.2~80~0.2~1~1~1;
liner5   = 1~2~20~0.25~80~0.25~1~1~1;
_pline   = liner1|liner2|liner3|liner4|liner5;

age      = trimr(age,1,0);
dat      = trimr(dat,1,0);

_plegctl = {2,5,1,5};   @ legend size and location @

cn       = cn+1;
dat2     = dat[.,cn];
titlestr = "Job Exit Rates, All Health Insurance Types";
_plegstr = "Data, All H.I.\000Simulations, All H.I.";
filestr  = rootdir $+ "aghaz.eps";
grphhaz(age,dat2,filestr,titlestr);

cn       = cn+1;
dat2     = dat[.,cn];
titlestr = "Job Exit Rates, No Health Insurance";
_plegstr = "Data, no H.I.\000Simulations, no H.I.";
filestr  = rootdir $+ "aghazn.eps";
grphhaz(age,dat2,filestr,titlestr);

cn       = cn+1;
dat2     = dat[.,cn];
titlestr = "Job Exit Rates, Retiree Health Insurance";
_plegstr = "Data, retiree H.I.\000Simulations, retiree H.I.";
filestr  = rootdir $+ "aghazr.eps";
grphhaz(age,dat2,filestr,titlestr);

cn       = cn+1;
dat2     = dat[.,cn];
titlestr = "Job Exit Rates, Tied Health Insurance";
_plegstr = "Data, tied H.I.\000Simulations, tied H.I.";
filestr  = rootdir $+ "aghazt.eps";
grphhaz(age,dat2,filestr,titlestr);

_plegctl = {2,5,1,4.7};   @ legend size and location @

dat2     = dat[.,7|8|9];
titlestr = "Job Exit Rates by Health Insurance Type, Data";
_plegstr = "Data, no H.I. \000Data, retiree H.I. \000Data, tied H.I.";
filestr  = rootdir $+ "hazdall.eps";
grphhaz(age,dat2,filestr,titlestr);

dat2     = dat[.,15|16|17];
titlestr = "Job Exit Rates by Health Insurance Type, Simulations";
_plegstr = "Simulations, no H.I. \000Simulations, retiree H.I. \000Simulations, tied H.I.";
filestr  = rootdir $+ "hazsall.eps";
grphhaz(age,dat2,filestr,titlestr);

@-----------------------------------------------------------------------------@
@--------------Graph lfpr disaggregated by preference indicator---------------@

load path = ^shkpath grphmat4;
" grphmat4 = " grphmat4;?;

dat      = grphmat4;
age      = dat[.,1];

cn       = 2|4|6;
dat2     = dat[.,cn];
_plegctl = {2,5,5,4.75};   @ legend size and location @
titlestr = "Participation Rates by Preference Index, Simulations";
_plegstr = "Simulations, Pref = out\000Simulations, Pref = low\000Simulations, Pref = high";
filestr  = rootdir $+ "lfprpis.eps";
grphlfp3(age,dat2,filestr,titlestr);


cn       = cn+1;
dat2     = dat[.,cn];
_plegctl = {2,5,5.7,4.75};   @ legend size and location @
titlestr = "Participation Rates by Preference Index, Data";
_plegstr = "Data, Pref = out\000Data, Pref = low\000Data, Pref = high";
filestr  = rootdir $+ "lfprpid.eps";
grphlfp3(age,dat2,filestr,titlestr);

@-----------------------------------------------------------------------------@
@-------------------------Graph pension accrual rates-------------------------@

load path = ^shkpath avgpacc;
" avgpacc = " avgpacc;?;

clear titlestr;
title (titlestr);
_plegstr  = "None\000Retiree\000Tied";
filestr   = rootdir $+ "simacc.eps";

age       = avgpacc[.,1];
y         = avgpacc[.,2:4];
x         = age*ones(1,cols(y));
_plegctl  = {2,5,6.63,5};  @ legend size and location @

ytics(-0.05,0.15,0.05,miss(0,0));
liner1    = 1~2~20~0.0~80~0.0~1~1~1;
liner2    = 1~2~20~0.05~80~0.05~1~1~1;
liner3    = 1~2~20~0.1~80~0.1~1~1~1;
_pline    = liner1|liner2|liner3;

ylabel("Accrual Rates");
xlabel("Age");
graphprt(filestr); 
xy(x,y);
pause(5);

end;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@

proc(0) = grphasst(dat,filestr,rn);

    local rscl, adl, adh, asl, ash, y, age, x, liner1, liner2, liner3,
          liner4, liner5, liner6, liner7;

    rscl = 1e3;

    adl=dat[.,15]*rscl; @ 1/3rd asset quantile, data @
    adh=dat[.,16]*rscl; @ 2/3rd asset quantile, data @
    asl=dat[.,30]*rscl; @ 1/3rd asset quantile, simulation @
    ash=dat[.,31]*rscl; @ 1/3rd asset quantile, simulation @
    if rn==2;
        y=adl~adh;
    elseif rn==4;
        y=adl~asl~adh~ash;
    endif;

    x=dat[.,1];

    if rn==2;
        _plegstr = "1/3rd quantile, data \0002/3rd quantile, data";
        _plegctl = {2,5,1,5.5};   @ legend size and location @
    elseif rn==4;
        _plegstr = "1/3rd quantile, data \0001/3rd quantile, simulations \0002/3rd quantile, data, \0002/3rd quantile, simulations";
        _plegctl = {2,5,1,5};   @ legend size and location @
    endif;

    liner1=1~2~20~50~80~50~1~1~1;
    liner2=1~2~20~100~80~100~1~1~1;
    liner3=1~2~20~150~80~150~1~1~1;
    liner4=1~2~20~200~80~200~1~1~1;
    liner5=1~2~20~250~80~250~1~1~1;
    liner6=1~2~20~300~80~300~1~1~1;
    liner7=1~2~20~350~80~350~1~1~1;

    _pline=liner1|liner2|liner3|liner4|liner5|liner6|liner7;
    
    ylabel("Assets (thousands of 1998 dollars)");
    xlabel("Age");

    ytics(0,350,50,miss(0,0));

    graphprt(filestr); 
    xy(x,y);
    pause(5);

retp; endp;

@-----------------------------------------------------------------------------@

proc(0) = grphhour(dat,filestr);

    local hd, ud, hs, us, y, age, x, liner1, liner2, liner3,
          liner4, liner5;

    hd=dat[.,3];   @ healthy hours, data          @
    ud=dat[.,2];   @ unhealthy hours, data        @
    hs=dat[.,18];  @ healthy hours, simulations   @
    us=dat[.,17];  @ unhealthy hours, simulations @
    y=exp(hd~hs~ud~us);

    x=dat[.,1];

    _plegctl = {2,5,1,1};  @ legend size and location @
    _plegstr = "Healthy, data \000Healthy, simulations \000Unhealthy, data \000Unhealthy, simulations ";

    liner1=1~2~20~1250~80~1250~1~1~1;
    liner2=1~2~20~1500~80~1500~1~1~1;
    liner3=1~2~20~1750~80~1750~1~1~1;
    liner4=1~2~20~2000~80~2000~1~1~1;
    liner5=1~2~20~2250~80~2250~1~1~1;
    _pline=liner1|liner2|liner3|liner4|liner5;

    ylabel("Hours");
    xlabel("Age");
    title ("Annual Hours Worked, Simulations Versus Data");
    ytics(1000,2500,250,miss(0,0));

    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;

@-----------------------------------------------------------------------------@

proc(0) = grphlfpr(dat,filestr);

    local hlfprd, ulfprd, hlfprs, ulfprs, y, age, x, liner1, liner2, 
          liner3, liner4;

    hlfprd=dat[.,5];   @ healthy lfpr, data          @
    ulfprd=dat[.,4];   @ unhealthy lfpr, data        @
    hlfprs=dat[.,20];  @ healthy lfpr, simulations   @
    ulfprs=dat[.,19];  @ unhealthy lfpr, simulations @
    y=hlfprd~hlfprs~ulfprd~ulfprs;

    x=dat[.,1];

    _plegctl = {2,5,1,1};  @ legend size and location @
    _plegstr = "Healthy, data \000Healthy, simulations \000Unhealthy, data \000Unhealthy, simulations ";

    liner1=1~2~20~0.2~80~0.2~1~1~1;
    liner2=1~2~20~0.4~80~0.4~1~1~1;
    liner3=1~2~20~0.6~80~0.6~1~1~1;
    liner4=1~2~20~0.8~80~0.8~1~1~1;
    _pline=liner1|liner2|liner3|liner4;

    ylabel("Participation Rates");
    xlabel("Age");
    title ("Labor Force Participation Rates, Data Versus Simulations");
    ytics(0,1,0.1,miss(0,0));
    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;

@-----------------------------------------------------------------------------@

proc(0) = grphlfp2(age,dat,filestr,titlestr);

    local y, x, liner1, liner2, liner3, liner4;

    y=dat;
    x=age;

    _plegctl = {2,5,1,1};  @ legend size and location @

    liner1=1~2~20~0.2~80~0.2~1~1~1;
    liner2=1~2~20~0.4~80~0.4~1~1~1;
    liner3=1~2~20~0.6~80~0.6~1~1~1;
    liner4=1~2~20~0.8~80~0.8~1~1~1;
    _pline=liner1|liner2|liner3|liner4;

    ylabel("Participation Rates");
    xlabel("Age");
    title (titlestr);
    ytics(0,1,0.1,miss(0,0));

    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;

@-----------------------------------------------------------------------------@

proc(0) = grphlfp3(age,dat,filestr,titlestr);

    local y, x, liner1, liner2, liner3, liner4;

    y=dat;
    x=age;

    liner1=1~2~20~0.2~80~0.2~1~1~1;
    liner2=1~2~20~0.4~80~0.4~1~1~1;
    liner3=1~2~20~0.6~80~0.6~1~1~1;
    liner4=1~2~20~0.8~80~0.8~1~1~1;
    _pline=liner1|liner2|liner3|liner4;

    ylabel("Participation Rates");
    xlabel("Age");
    title (titlestr);
    ytics(0,1,0.1,miss(0,0));

    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;

@-----------------------------------------------------------------------------@

proc(0) = grphhaz(age,dat,filestr,titlestr);

    local x, y;

    y=dat;
    x=age*ones(1,cols(y));
    ylabel("Job Exit Rates");
    xlabel("Age");
    title(titlestr);
    graphprt(filestr); 
    xy(x,y);
    pause(5);

 retp; endp;

