library pgraph;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@
/*
GETSE:   compute standard errors
*/
proc(4)= getse(params,ptcnum);
    local D1, _D, Ovid, DD, DDsc, DOmD, stderr, tstat, h, uwmmts, _v, _w, vinv, 
          D0grad, Dgrad, _P, _Q, _tau, nmom, df, colkeep, zn, rn2, gs0, gradstep,
          stepchk, bigenuf,

   @--------------------Matrices of simulated statistics---------------------@
      uhm, upm, am, hhm, hpm, simhazn, simhazr, simhazt, simlfprn, simlfprr,
      simlfprt, simlfpr0, simlfpr1, simlfpr2, qnmod, qcmmod, qcnmod, dqnmod, cn, 

   @--------------Matrices of pdfs and Conditional Expectations--------------@
      apdf, acpdf, qptcm, acpdfnum, acdf,

   @---------------------------Matrices of Raw Data---------------------------@
      uhdat, hhdat, updat, hpdat, xdatn, xdatr, xdatt, pdatn, pdatr, pdatt, 
      pdat0, pdat1, pdat2, adat, 

   @-----------------------------Moment Matrices------------------------------@
      rldata2, rldata3, obsmat, hswgts;

   @----Recompute the vcv matrix and its inverse, vinv, using model means----@
   @----------------------(but the same data as before)----------------------@
    "params=" params;                                 @  This should be px1  @
    {uhm,hhm,upm,hpm,simhazn,simhazr,simhazt,simlfprn,simlfprr,simlfprt,
     simlfpr0,simlfpr1,simlfpr2,qnmod,qcmmod,qcnmod} = modmoms(params);
    load path= ^datapath uhdat, hhdat, updat, hpdat, xdatn, xdatr, xdatt, 
                         pdatn, pdatr, pdatt, pdat0, pdat1, pdat2, adat;
    if truevcv == 1;
        rldata2 = makemmts(totobs,uhm,hhm,upm,hpm,simhazn,simhazr,simhazt,
                           simlfprn,simlfprr,simlfprt,simlfpr0,simlfpr1,simlfpr2,
                           qnmod,qcmmod,uhdat,hhdat,updat,hpdat,xdatn,xdatr,xdatt,
                           pdat0,pdat1,pdat2,pdatn,pdatr,pdatt,adat);
    else;
        rldata2 = makmmts2(totobs,uhm,hhm,upm,hpm,simhazn,simhazr,simhazt,
                           simlfprn,simlfprr,simlfprt,simlfpr0,simlfpr1,simlfpr2,
                           qnmod,qcmmod,uhdat,hhdat,updat,hpdat,xdatn,xdatr,xdatt,
                           pdat0,pdat1,pdat2,pdatn,pdatr,pdatt,adat);
    endif;
    clear uhdat, hhdat, updat, hpdat, xdatn, xdatr, xdatt, pdatn, pdatr, pdatt, 
          pdat0, pdat1, pdat2, adat;
    load path = ^datapath obsmat; 
    rldata2 = rldata2.*obsmat;@ zero out missing obs.  hswgts also does this, @
                                  @ but this makes rldata easier to interpret @  
    clear obsmat;
    save path = ^datapath rldata2;
    load path = ^datapath hswgts;
    dist = rldata2.*hswgts; 
    clear rldata2, hswgts;
    dist = meanc(dist');
    modmns = zeros(rows(dist),1);      @ makemmts returns centered moments    @
                                       @ if the model is true, E(rldata2) = 0 @
    {_v, _w, vinv} = compvinv(modmns,totobs);@ _v, vinv should be MxM, where  @
                                       @ M is the number of moment conditions @
   @------Evaluate pdfs and conditional expectations at model quantiles-------@
    load path = ^datapath rldata3; 
    cn = cols(rldata3)/datayrs;
    if nosaving==0;
        {apdf, acpdf, qptcm, acpdfnum, acdf} = getkern(rldata3,cn,quants,bornage,qnmod);
    elseif nosaving==1;
        apdf=0;  acpdf=0;  qptcm=0;  acpdfnum=0;  acdf=0;
    endif;
    clear rldata3, acpdfnum;

   @-----------Find Jacobian for model-predicted summary statistics-----------@
   @-----------------This should be Mxp, p = # of parameters------------------@ 

    colkeep = seqa(1,1,9+2*ntypes+(ntypes-1)*ptcnum);  @ Exclude fixed values @
    colkeep = freevec.*colkeep;                                
    colkeep  = sortc(colkeep,1);
    zn       = sumc(colkeep.< 0.99);
    colkeep  = colkeep[zn+1:rows(colkeep)];

    gs0      = 0.025;
    gradstep = ones(rows(params),1)*gs0;

    if ntypes == 3;
        stepchk  = abs(params[16:39])~(0.01*ones(24,1)); @ size of parm sets size of step @
        stepchk  = maxc(stepchk');
        stepchk  = 0.5*(stepchk.^(-1));                     @ set step as if |parm| = 0.5 @
        bigenuf  = stepchk.<1;
        stepchk  = stepchk.*(1-bigenuf) + bigenuf;
        gradstep[16:39] = gs0*stepchk;

/*
if nosaving==1; gradstep[6] = 8*gs0; endif;
gradstep[15] =  0.1*stepchk[1];
gradstep[16] = -0.1*stepchk[2];
*/

    endif;


    _D = gradp2(&modmoms2,params,gradstep);
    D0grad = _D;
    save path = ^shkpath D0grad; 

"_D =";;_D;

   @------------Combine everything to get no-missing-data gradient------------@
    _D = getgrad(_D,qcmmod,apdf,acpdf,qptcm,acdf);
    Dgrad = _D;
    save path = ^shkpath Dgrad; 

/* load path = ^shkpath Dgrad; _D = Dgrad; */

    load path = ^datapath hswgts;                      @  This should be MxI  @
    D1 = meanc(hswgts');                               @  "            " Mx1  @
    clear hswgts; 

    _D  = _D.*D1;
    _D  = _D[.,colkeep];                @ Drop gradients for fixed parameters @
    rn2 = rows(colkeep);

    "D = " _D;        @ _D should be Mxp, where p is the number of parameters @
    if optimal==0; 
        DD   = _D'*_w*_D;                                  @ DD should be pxp @
        DDsc = diagrv(eye(rn2),diag(DD)^-1);   @ Improves numerical stability @
        DD   = DD*DDsc;
        DOMD = _D'*_w*_v*_w*_D*DDsc;
        VCV  = DDsc*inv(DD)*DOmD*inv(DD);
        "DD = ";; DD*inv(DDsc);
        "DOMD = ";; DOMD*inv(DDsc);                          
    elseif optimal==1; 
        DD   = _D'*vinv*_D;
        DDsc = diagrv(eye(rn2),diag(DD)^-1);   @ Improves numerical stability @
        DD   = DD*DDsc;
        VCV  = DDsc*inv(DD);
    endif;

    _tau   = totobs/_nn;
    VCV    = (1+_tau)*VCV/totobs; 
    stderr = zeros(rows(params),1);
    stderr[colkeep] = sqrt(diag(VCV));
    tstat  = params./stderr;
    
    ?;"Variance covariance matrix = ";; VCV;
    ?;"standard errors and t-stats = " params~stderr~tstat;?;

   @-------------------------Overidentification test--------------------------@
    nmom = rows(_D);
    if optimal==0;                           @ Formula from Newey (JoE, 1995) @
       _P   = eye(nmom) - _D*DDsc*inv(DD)*_D'*_w;
       _Q   = _P*_v*_P';   @ Use Moore-Penrose (generalized) inverse to invert @
       Ovid = totobs*dist'*pinv(_Q)*dist/(1+_tau);
    elseif optimal==1;
       Ovid = totobs*dist'*vinv*dist/(1+_tau);
    endif;
   "Overidentification statistic = ";; Ovid;
   df = nmom-cols(_D);
   "Degrees of Freedom =           ";; df;
   "p-value =                      ";; cdfchic(ovid,df);?;


retp(VCV, stderr, tstat, Ovid); endp;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@
/*
MODMOMS:  calculates the vector of moments for GMM estimation
*/
proc(16) = modmoms(params);

   @-----------------prefix "h" => healthy, "u" => unhealthy------------------@
   @----------------"h" => hours, "a" => assets, "p" => LFPR------------------@

local j, i, cn,  
   @------------------------Matrices of Value Functions-----------------------@
      Vmata, Vmatn, 

   @--------------------Matrices of Simulated Time Series---------------------@
      csim, hsim, psim, asim, hitsim,

   @-----------------------and their conditional means------------------------@
      uhm, upm, am, hhm, hpm, simhazn, simhazr, simhazt, simlfprn, simlfprr, 
      simlfprt, simlfpr0, simlfpr1, simlfpr2, qnmod, qcmmod, qcnmod;

    j=0; 
    format /ro 12,4;

   @-------Get Decision Rules:  Note that parameters are already scaled-------@
    getparms(params);       @ Convert scaled parameter vector into parameters @
    cdec[cflrind] = cfloor;                                @ cdec is a global @
    {Vmata,Vmatn} = rule();
    clear Vmata, Vmatn;

   @-------------Simulate time series and find conditional means--------------@
    {csim, hsim, psim, asim, hitsim} = sim();
    save path = ^shkpath csim, hsim, psim, asim, hitsim;
    clear csim, hsim, psim, asim, hitsim;

    {uhm, upm, hhm, hpm, am, simhazn, simhazr, simhazt, simlfprn, simlfprr, 
     simlfprt, simlfpr0, simlfpr1, simlfpr2, qnmod, qcmmod, qcnmod} = condmean(); 

    date1=date; date1[4,.]=date1[4,.]/360000;
    "years, months, days, hours, just finished simulations" (date1-sttime)';?;  

    hhm = hhm[1:datayrs,.];
    uhm = uhm[1:datayrs,.];
    hpm = hpm[1:datayrs,.];
    upm = upm[1:datayrs,.];
    am  = am[1:datayrs,.];
    simhazn  = simhazn[1:datayrs,.];
    simhazr  = simhazr[1:datayrs,.];
    simhazt  = simhazt[1:datayrs,.];
    simlfpr0 = simlfpr0[1:datayrs,.];
    simlfpr1 = simlfpr1[1:datayrs,.];
    simlfpr2 = simlfpr2[1:datayrs,.];

    qnmod  = qnmod[2:datayrs+1,2:qnum+1];                 @ Eliminate headers @
    cn     = cols(qcmmod);
    qcmmod = qcmmod[2:datayrs+1,2:cn];                    @ Eliminate headers @
    qcnmod = qcnmod[2:datayrs+1,2:cn];                    @ Eliminate headers @  
 
retp(uhm,hhm,upm,hpm,simhazn,simhazr,simhazt,simlfprn,simlfprr,simlfprt,
     simlfpr0,simlfpr1,simlfpr2,qnmod,qcmmod,qcnmod); 
endp;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@
/*
MODMOMS2:  calculates the vector of sample statistics predicted by the model
*/
proc(1) = modmoms2(params);

   @-----------------prefix "h" => healthy, "u" => unhealthy------------------@
   @----------------"h" => hours, "a" => assets, "p" => LFPR------------------@
   @---------------suffix "a" => applying, "n" => not applying----------------@

local i, rn, cn, uhm, upm, am, hhm, hpm, simhazn, simhazr, simhazt, 
      simlfprn, simlfprr, simlfprt, simlfpr0, simlfpr1, simlfpr2, 
      qnmod, qcmmod, qcnmod, modstats;

    {uhm,hhm,upm,hpm,simhazn,simhazr,simhazt,simlfprn,simlfprr,simlfprt,
     simlfpr0,simlfpr1,simlfpr2,qnmod,qcmmod,qcnmod} = modmoms(params);
    modstats = uhm[mashft:datayrs,.]|hhm[mashft:datayrs,.];
    modstats = modstats|upm[mashft:datayrs,.]|hpm[mashft:datayrs,.];
    modstats = modstats|simhazn[(mashft+hazshft):datayrs,.]; @ hazard rates might have 1 less year @
    modstats = modstats|simhazr[(mashft+hazshft):datayrs,.];
    modstats = modstats|simhazt[(mashft+hazshft):datayrs,.];
    if prefmoms>0;
        modstats = modstats|simlfpr0[mashft:datayrs,.]|simlfpr1[mashft:datayrs,.];
        modstats = modstats|simlfpr2[mashft:datayrs,.];
    endif;

    rn = qnum+1;

    if nosaving==0;
        i=1; do until i>rn;
            modstats = modstats|qcmmod[mashft:datayrs,4*rn+i]; 
            modstats = modstats|qcmmod[mashft:datayrs,5*rn+i]; 
            modstats = modstats|qcmmod[mashft:datayrs,6*rn+i]; 
        i=i+1; endo;

        i=1; do until i>rn-1;
            modstats = modstats|qnmod[mashft:datayrs,i]; 
        i=i+1; endo;

    elseif nosaving==1;
        modstats = modstats|simlfprn[mashft:datayrs,.]|simlfprr[mashft:datayrs,.];
    endif;        

   
retp(modstats); endp;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@
/*
GETKERN:  Evaluates asset pdf at quantile points
          Evaluates E(P|A) at asset quantile points
*/

proc(5) = getkern(data,sc,quants,bornage,qnvals);

    local qnum, srtddata, qnts, rn0, rn, rn2, cn, cn2, qn, qno, qptcm, apdf,
          acpdfnum, acpdf, h, i, j, k, srtd2, srtd3, qnt, age, cnmn, nodat,  
          kdns, dkdns, bw, assets, npm, dnpm, qnvals2, x_axis, acdf, rn3,
          kdns_53, kdns_67;

    qnum  = rows(quants);
    nodat = -10;
    rn0   = rows(data);
    data  = missrv(data,mvcode);
    cn    = cols(data)/datayrs; 
    apdf  = zeros(datayrs+1,2*qnum+1);
    apdf[1,2:2*qnum+1] = (quants|quants)';
    qptcm = zeros(datayrs+1,qnum*cn+1);
    qptcm[1,2:qnum*cn+1] = (ones(cn,1).*.quants)';
    acpdf = qptcm;
    acpdfnum = qptcm;
    acdf  = qptcm;

    h=1; do until h > datayrs;
        age = bornage + h - 1;
        apdf[h+1,1]  = age;
        qptcm[h+1,1] = age;
        acpdf[h+1,1] = age;
        acpdfnum[h+1,1] = age;
        acdf[h+1,1]  = age;
        cn2 = seqa(h,datayrs,cn); 
        srtddata = data[.,cn2];       @ Extract the obs for a particular age @
        srtddata = sortc(srtddata,sc);    @ Here sc gives the asset column # @
        k = (srtddata[.,sc].==mvcode);
        k=k'k; 
        if k == rn0;
            "No observations at age";; age;
            h=h+1;
            continue;
        endif;
       @---------------Remove missing obs for sorting variable---------------@
        srtddata = srtddata[k+1:rn0,.];
        assets   = srtddata[.,sc];
        rn       = rn0-k;               @ Number of non-missing observations @

       @----------Find the kernel densities of assets for this age-----------@
        {kdns, dkdns, bw} = ukernel(qnvals[h,.]',assets,0,1,&k_gauss);
        apdf[h+1,2:1+qnum] = kdns';
        x_axis = seqa(-.1,1/200,220);
        if h==1;
            {kdns, dkdns, bw} = ukernel(x_axis,assets,0,1,&k_gauss);
            kdns_53 = kdns;
        elseif h==datayrs;
            {kdns, dkdns, bw} = ukernel(x_axis,assets,0,1,&k_gauss);
            kdns_67 = kdns;
        endif;                 
        qno = 0;
        i=1; do until i>qnum;
            qn = sumc(assets.<=qnvals[h,i]);
            rn2 = qn-qno;
            apdf[h+1,qnum+i+1] = rn2;       @ Counts for interval (q_i-1,q_i] @
            qno = qn;
        i=i+1; endo;
    
       @---Find asset densities, conditional on observing other variables----@
       @--and find conditional expectations conditional on asset quantiles---@ 
        
        j=1; do until j>cn;
            if j==sc; 
                j=j+1; continue; 
            endif;
           @---------Check to see if non-asset variable is observed----------@
            srtd2  = sortc(srtddata,j);         @ Sort on non-asset variable @
            k      = (srtd2[.,j].==mvcode);
            k      = k'k;
            if k==rows(srtd2);
                j=j+1; continue;
            endif;
            srtd2  = srtd2[k+1:rn,.];
            srtd2  = sortc(srtd2,sc);
            assets = srtd2[.,sc];
            rn3    = rn - k;

           @--------Find the kernel densities of assets for this age---------@
            {kdns, dkdns, bw} = ukernel(qnvals[h,.]',assets,0,1,&k_gauss);
            acpdf[h+1,(j-1)*qnum+2:j*qnum+1] = kdns';
            qno = 0;
            i=1; do until i>qnum;
                qn = sumc(assets.<=qnvals[h,i]);
                acdf[h+1,(j-1)*qnum+1+i] = qn/rn3;@ Asset cdf conditional on @
                rn2 = qn-qno;                 @ this variable being observed @
                acpdfnum[h+1,(j-1)*qnum+1+i] = rn2; 
                                          @ Counts for interval (q_i-1,q_i] @
                qno = qn;
            i=i+1; endo;

           @-----Find the conditional expections of non-asset variables-----@
            srtd3 = srtd2[.,j];
            {npm, dnpm, bw} = nw(qnvals[h.,]',assets,srtd3,0,&k_gauss);
            qptcm[h+1,(j-1)*qnum+2:j*qnum+1] = npm';

        j=j+1; endo;  @ end loop through variables @

    h=h+1; endo; @ end loop through years @


    "Asset pdf at ages";; bornage;;" and";; momage2;
    " Assets($MM)         pdf0         pdf1 ";;x_axis~kdns_53~kdns_67;?;

    "        age       asset pdfs and cell counts";; apdf;?;
    "Asset pdfs for observations where other variables are observed";
    prlabel2; acpdf;?;
    "Conditional asset cdfs"; prlabel2; acdf;?;
    "Counts (for checking)"; prlabel2; acpdfnum;?;
    "Asset-Point-conditional Means"; prlabel2; qptcm;?;

    apdf  = apdf[(mashft+1):(datayrs+1),2:qnum+1];        @ Eliminate headers @
    acpdf = acpdf[(mashft+1):(datayrs+1),2:qnum*cn+1];  @ as well as 1st year @
    acdf  = acdf[(mashft+1):(datayrs+1),2:qnum*cn+1];
    qptcm = qptcm[(mashft+1):(datayrs+1),2:qnum*cn+1]; 

retp(apdf,acpdf,qptcm,acpdfnum,acdf); endp;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@

proc(1) = getgrad(D0,qcm,apdf,acpdf,qptcm,acdf);

    local rn,rn2,cn,cn2,cn3,cn4,D0temp,pdftemp,dgtemp0,dgtemp1,cmtemp,i,j,k,
          Dtemp,_D,cdftemp;

    qcm = qcm[mashft:datayrs,.];
    rn  = 4*momyrs;                     @ start of HIT-conditional exit rates @
    rn  = rn + 3*(momyrs-hazshft);    @ start of preference-conditional LFPRs @
    if prefmoms>0;                                         @ if they are used @
        rn = rn + 3*momyrs;         @ start of HI-&quantile-conditional LFPRs @
    endif;

    if nosaving==1;
        _D  = D0[1:rn+2*momyrs,.];          @ Include LFPR for none & retiree @
        goto skipasst;
    endif;

    _D  = D0[1:rn,.];@ Health-conditional expected hours, lfpr and exit rates @
    rn2 = rn + 3*(qnum+1)*momyrs;                  @ start of asset quantiles @

   @--------Now modify the gradient for the quantile-conditional means--------@
   @--Note that the qcms and pdfs are grouped by variable (then asset level)--@
   @--- but moments (& grads) will be grouped by asset level (then variable)--@

    cn  = 4*qnum;          @ start of pdfs for HI-&quantile-conditional LFPRs @

   @----------Analyze means conditional on assets <= first quantile-----------@
    dgtemp1 = D0[rn2+1:rn2+momyrs,.];                  @ dg_pi_1/dtheta:  Txp @
    i=1; do until i>HITnum;                                        @ HI types @
        D0temp  = D0[rn+1:rn+momyrs,.];                   @ dP_1/dtheta:  Txp @
        rn      = rn+momyrs;                                   @ Next HI type @
        cn2     = cn+(i-1)*qnum+1;
        pdftemp = acpdf[.,cn2];                           @ f(g_pi_1|HI): Tx1 @
        cdftemp = acdf[.,cn2];                      @ Pr(A_it <= g_pi_1 | HI) @
        D0temp  = D0temp.*cdftemp;
        cmtemp  = qcm[.,cn2]-qptcm[.,cn2];    @ P_1(HI)-E(P|HI,A=g_pi_1): Tx1 @
        Dtemp   = D0temp + cmtemp.*pdftemp.*dgtemp1;
        _D      = _D|Dtemp;
    i=i+1; endo;

    j=2; do until j > qnum;                                   @  Asset groups @ 
        dgtemp0 = dgtemp1;                           @ dg_pi_j-1/dtheta:  Txp @
        rn2     = rn2 + momyrs;                         @ Next asset quantile @
        dgtemp1 = D0[rn2+1:rn2+momyrs,.];              @ dg_pi_j/dtheta:  Txp @
        i=1; do until i>HITnum;                                    @ HI types @
            D0temp  = D0[rn+1:rn+momyrs,.];               @ dP_j/dtheta:  Txp @
            rn      = rn+momyrs;
            cn2     = cn+(i-1)*qnum+(j-1);
            pdftemp = acpdf[.,cn2];                     @ f(g_pi_j-1|HI): Tx1 @
            cdftemp = acdf[.,cn2];                  @ Pr(A_it <= g_pi_1 | HI) @
            cdftemp = acdf[.,cn2+1] - cdftemp;
                                          @ Pr(g_p_j-1 < A_it <= g_pi_j | HI) @
            D0temp  = D0temp.*cdftemp;
            cmtemp  = qcm[.,cn2]-qptcm[.,cn2];@ P_j-1(HI) - E(P|HI,A=g_pi_j-1) @
            Dtemp   = D0temp - cmtemp.*pdftemp.*dgtemp0;
            cn2     = cn2+1;
            pdftemp = acpdf[.,cn2];                       @ f(g_pi_j|HI): Tx1 @
            cmtemp  = qcm[.,cn2]-qptcm[.,cn2];@ P_j(HI)-E(P|HI,A=g_pi_j): Tx1 @
            Dtemp   = Dtemp + cmtemp.*pdftemp.*dgtemp1;
            _D      = _D|Dtemp;
        i=i+1; endo;
    j=j+1; endo;

   @----Analyze means conditional on assets > final (Jth, qnumth) quantile----@
    dgtemp0 = dgtemp1;                                 @ dg_pi_J/dtheta:  Txp @
    i=1; do until i>HITnum;                                        @ HI types @
        D0temp  = D0[rn+1:rn+momyrs,.];                   @ dP_J/dtheta:  Txp @
        rn      = rn+momyrs;
        cn2     = cn+i*qnum;
        pdftemp = acpdf[.,cn2];                           @ f(g_pi_J|HI): Tx1 @
        cdftemp = 1 - acdf[.,cn2];                    @ Pr(g_p_J < A_it | HI) @
        D0temp  = D0temp.*cdftemp;
        cmtemp  = qcm[.,cn2]-qptcm[.,cn2];  @ P_J+1(HI)-E(P|HI,A=g_pi_J): Tx1 @
        Dtemp   = D0temp - cmtemp.*pdftemp.*dgtemp0;
        _D      = _D|Dtemp;
    i=i+1; endo;

   @-------------Now modify the gradient for the asset quantiles--------------@
    cn=cn2;
    rn~((10+3*prefmoms)*momyrs)~rows(D0);
    cn~(7*qnum);

    j=1; do until j > qnum;                                   @  Asset groups @ 
        D0temp  = D0[rn+1:rn+momyrs,.];                @ dg_pi_j/dtheta:  Txp @
        rn      = rn+momyrs;
        pdftemp = apdf[.,j];                                 @ f(g_pi_J): Tx1 @
        Dtemp   = D0temp.*pdftemp;
        _D      = _D|Dtemp;
    j=j+1; endo;

    skipasst:

retp(_D); endp;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@

proc(0) = prlabel2;

    "       age          ------uhours------       -------hhours-------";;
    "      -------upart-------        ------hpart------         ";;
    "-----partnone----         -----partret-----         ";;
    "----partied-----          ------assets-----";;

retp; endp;

@-----------------------------------------------------------------------------@
@-----------------------------------------------------------------------------@

